// BackupMBR.cpp : Defines the entry point for the console application.
//
#include <Windows.h>

#include "types.h"
#include "utils.h"
#include <iostream>
#include <iomanip>
#include <vector>
#include <fstream>

#include "stdafx.h"

#define MBR_SIZE 0x200
using namespace std;

int main()
{
	
	//open device //windows
    HANDLE handle_r = ::CreateFileA("\\\\.\\PhysicalDrive0"
                                    , GENERIC_READ
                                    , FILE_SHARE_READ | FILE_SHARE_WRITE
                                    , 0
                                    , OPEN_EXISTING
                                    , FILE_ATTRIBUTE_NORMAL
                                    , 0);

    if(handle_r == INVALID_HANDLE_VALUE)
    {
            cout<<"Can't open file";
            return 0;
    }

	u_char buffer[MBR_SIZE];


    // get mbr //windows
    u_long result_;
    if(!ReadFile(handle_r, buffer, MBR_SIZE, &result_, 0))
	{
		CloseHandle(handle_r);
		cout<<"Can't read file";
		return 0;
	}

    HANDLE handle_w = ::CreateFileA("mbr_backup"
									, GENERIC_WRITE
									, FILE_SHARE_READ | FILE_SHARE_WRITE
									, 0
									, CREATE_ALWAYS
									, FILE_ATTRIBUTE_NORMAL
									, 0);

	if(handle_w == INVALID_HANDLE_VALUE)
	{
		cout<<"Can't open file";
		return 0;
	}

	if(!WriteFile(handle_w, buffer, MBR_SIZE, &result_, 0))
	{
		CloseHandle(handle_r);
		cout<<"Can't write file";
		return 0;
	}
	
	//get drive info
	drive_info drive_info_;
	if(get_drive_info(handle_r, drive_info_))
	{
		//store disk geometry
		store_drive_geometry(drive_info_);
	}
	
	// close handles
    CloseHandle(handle_r);
	CloseHandle(handle_w);

	return 0;
}


